defmodule Nulla.KeysTest do
  use NullaWeb.ConnCase, async: false
  import Nulla.Fixtures.Data
  alias Nulla.Models.User
  alias Nulla.Models.Actor

  setup do
    create()
    :ok
  end

  test "verify user's keys" do
    actor = Actor.get_actor(preferredUsername: "test")
    user = User.get_user(id: actor.id)

    message = "test message"

    private_key =
      :public_key.pem_decode(user.privateKeyPem)
      |> hd()
      |> :public_key.pem_entry_decode()

    public_key =
      :public_key.pem_decode(actor.publicKey["publicKeyPem"])
      |> hd()
      |> :public_key.pem_entry_decode()

    signature = :public_key.sign(message, :sha256, private_key)

    assert :public_key.verify(message, :sha256, signature, public_key)
  end
end
